/*
 * Extended presence data block
 *
 * Copyright (C) 2007 Grigory Holomiev <omever@gmail.com>.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 *
 */

#ifndef PEXTDATABLOCK_H
#define PEXTDATABLOCK_H

#include <string>

#include <libicq2000/buffer.h>
#include <libicq2000/Capabilities.h>

namespace ICQ2000 {
 
  class PExtDataBlock {
   protected:
    unsigned short m_avatar_id;
    unsigned char m_avatar_hashlen, m_avatar_flags;
    unsigned char m_avatar_hash[16];
    std::string m_mood, m_moodicon, m_tune;
    
   public:
    PExtDataBlock();

    unsigned short getAvatarId() const;
    unsigned char getAvatarHashlen() const;
    unsigned char getAvatarFlags() const;
    const unsigned char * getAvatarHash() const;
    std::string getMood() const;
    std::string getMoodIcon() const;
    std::string getTune() const;

    void Parse(Buffer& b);
  };

}

#endif
